
//+------------------------------------------------------------------+
//|   Dynamic Fibonacci Grid (DFG v1.33+ Dark) * Updated MQL4        |                                                      
//+------------------------------------------------------------------+

#property description "MTF Dynamic Fibonacci Grid"
#property strict
#property indicator_chart_window

input int Grid_Range = 30;
input int Additional_Width = 0;

#define NFL    10       // number of fibo levels
#define NSVL   17       // number of solid vertical lines
#define NMA    7        // number of MAs, change fma_period[NMA-1] accordingly 
#define NTF    5        // number of time frames/lanes, change tfp[NTF] accordinlgy



double   fma[NTF][NMA];          // fibo MAs
double   fib_up[NTF][NFL];       // fibo levels to the up side
double   fib_down[NTF][NFL];     // fibo levels to the down side
double   fib[NFL];               // fibo distances ('pip_Point' adjusted)
double   srl[30];                // support/resistance levels (total = 2*NFL + NMA + 1(Bid) )
double   gap = 10.1;
double   bid_Price, pip_Point;
double   fmaArray[NMA], lowestMA, highestMA;
int      _fib[NFL] = {10,16,26,42,68,110,178,288,466,754};     // fibo levels in pips : 10, 16, 26, 42, 68, 111, 179, 290, 470, 760
int      fma_period[NMA] = {13, 21, 34, 55, 89, 144, 233};              // SMAs, NMA-1
int      tfp[NTF] = {1, 5, 15, 60,240};                                     // Time frames/lanes - in minutes. Like H4=240, D1=1440 etc...
int      i, tf, c, offset, xUnit;
int      shift, spacing, width, supports, resistances;
int      short_gap_count;
int      long_gap_count;
int      sr_short_gap_count;
int      sr_long_gap_count;
int          VWidth = 28;
color    ShadeUpper[NFL] = {C'200,240,255', C'160,220,255', C'120,200,255', C'80,180,255', C'40,140,255', C'20,100,255', C'0,60,240', C'0,40,220', C'0,20,200'};
color    ShadeLower[NFL] = {C'255,210,165', C'255,180,100', C'255,165,70', C'255,145,35', C'255,130,10', C'230,115,0', C'185,95,0', C'155,80,0', C'120,60,0'};
color    col;
string   objName, name;
string   uniqueid = "DFG: ";
string   string_1;
int      string_L;
string   string_x;
datetime curTime;

//Pivot -------------------------------------------------------------------------------------//

extern bool brokercandle=true;//Broker's Candle
extern datetime startofpivot=D'2016.09.12 07:00';//Choose H1 Start Candle
extern datetime endofpivot=D'2016.09.19 06:00';//Choose H1 Finish Candle
extern bool StartEndLines=true;//Display Start and End lines for manual settings
extern string  comment1="Choose the TF ";
//--
enum TFOfPivot
  {
   M=1,     // MN
   W=2,     // W1
   D=3,     // D1
  };
input TFOfPivot swaptf=2;
//--
extern string  comment2="Choose Pivot Method ";
//--
enum PivotMethod
  {
   HLC=1,      // Avg of High, Low, Close
   HLCC=2,     // Avg of High, Low, Close, Close
   HLOC=3,     // Avg of High, Low, Open, Close
   HLOO=4,     // Avg of High, Low, Open, Open
   HLO=5,// Avg of High, Low, Open
  };
input PivotMethod pivot_meth=1;
//--
extern bool pivot_fib=true;//Choose Fib(true) or Standard(false)
extern color chose_color_pivot = clrYellow;
extern color label_color_pivot = clrYellow;
extern int width_of_pivot_line = 0;
extern int line_style_of_pivot = 4;
extern color chose_color_R38 = clrMagenta;
extern color label_color_R38 = clrMagenta;
extern color chose_color_R61 = clrLimeGreen;
extern color label_color_R61 = clrLimeGreen;
extern color chose_color_R78 = clrRed;
extern color label_color_R78 = clrRed;
extern color chose_color_R100 = clrAqua;
extern color label_color_R100 = clrAqua;
extern color chose_color_R138 = clrOrange;
extern color label_color_R138 = clrOrange;
extern color chose_color_R161 = clrBlack;
extern color label_color_R161 = clrBlack;
extern color chose_color_R200 = clrBrown;
extern color label_color_R200 = clrBrown;
extern int width_of_R_line = 0;
extern int line_style_of_R = 1;
extern color chose_color_S38 = clrMagenta;
extern color label_color_S38 = clrMagenta;
extern color chose_color_S61 = clrLimeGreen;
extern color label_color_S61 = clrLimeGreen;
extern color chose_color_S78 = clrGreen;
extern color label_color_S78 = clrGreen;
extern color chose_color_S100 = clrAqua;
extern color label_color_S100 = clrAqua;
extern color chose_color_S138 = clrOrange;
extern color label_color_S138 = clrOrange;
extern color chose_color_S161 = clrBlack;
extern color label_color_S161 = clrBlack;
extern color chose_color_S200 = clrBrown;
extern color label_color_S200 = clrBrown;
extern int width_of_S_line = 0;
extern int line_style_of_S = 1;
extern int LL=40;//Length of lines 
extern int SS=0;//Shift to right
extern bool show_200=false;//Show all S&R to 200% 
extern bool ShortHorizontalLines=false;//Short(default) or Long(with price labels) horizontal lines
                                       //--
double wclose= 0;
double wopen = 0;
double whigh = 0;
double wlow=0;
//--
double calPivot = 0;
double calRange = 0;
//--
double R38  = 0;
double R61  = 0;
double R78  = 0;
double R100 = 0;
double R138 = 0;
double R161 = 0;
double R200 = 0;
//--
double S38  = 0;
double S61  = 0;
double S78  = 0;
double S100 = 0;
double S138 = 0;
double S161 = 0;
double S200 = 0;
//--
double R1 = 0;
double R2 = 0;
double R3 = 0;
double S1 = 0;
double S2 = 0;
double S3 = 0;
//--
int    chose_tf;
string lableR38;
string lableR61;
string lableR78;
string lableR100;
string lableS38;
string lableS61;
string lableS78;
string lableS100;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   ChartSetSymbolPeriod(NULL, Symbol(), PERIOD_W1);   
  
   xUnit   = _Period * 60;
   shift   = -140 * xUnit - Additional_Width * 4 * xUnit;
   spacing = 25 * xUnit + Additional_Width * xUnit;
   width   = 24 * xUnit + Additional_Width * xUnit;

   bid_Price = Bid;
          
   pip_Point = 0.01;
   if(_Digits > 3) pip_Point = 0.0001;

   ChartSetInteger(0,CHART_SCALE, 0);    
   ChartSetInteger(0,CHART_AUTOSCROLL, true);
   ChartSetInteger(0,CHART_SHIFT, true);
   ChartSetInteger(0,CHART_MODE, CHART_LINE);
   ChartSetInteger(0,CHART_SHOW_GRID, false);
   ChartSetInteger(0,CHART_SHOW_PERIOD_SEP, false);  
   ChartSetInteger(0,CHART_SHOW_OHLC, false);  
   ChartSetInteger(0,CHART_SHOW_BID_LINE, false); 
   ChartSetInteger(0,CHART_SHOW_ASK_LINE, false); 
   ChartSetInteger(0,CHART_SHOW_OBJECT_DESCR, false);     
   ChartSetInteger(0,CHART_SHOW_VOLUMES, CHART_VOLUME_HIDE);
   ChartSetInteger(0,CHART_SHOW_ONE_CLICK, false);
   ChartSetInteger(0,CHART_FOREGROUND, false);   
         
   ChartSetInteger(0,CHART_COLOR_CHART_LINE, clrNONE);
   ChartSetInteger(0,CHART_COLOR_BACKGROUND, C'11,11,11');
   ChartSetInteger(0,CHART_COLOR_FOREGROUND, C'11,11,11');
   ChartSetInteger(0,CHART_COLOR_GRID, clrNONE);     
   ChartSetInteger(0,CHART_COLOR_CANDLE_BULL, clrNONE);
   ChartSetInteger(0,CHART_COLOR_CANDLE_BEAR, clrNONE);      
   ChartSetInteger(0,CHART_COLOR_CHART_UP, clrNONE);
   ChartSetInteger(0,CHART_COLOR_CHART_DOWN, clrNONE);  
   ChartSetInteger(0,CHART_COLOR_VOLUME, clrGreen);  
   ChartSetInteger(0,CHART_COLOR_STOP_LEVEL, clrRed);  
               
   ChartSetInteger(0,CHART_SHOW_DATE_SCALE, false);
   ChartSetInteger(0,CHART_SHOW_PRICE_SCALE, false);
   ChartSetInteger(0,CHART_SCALEFIX, true);
   ChartSetDouble(0,CHART_FIXED_MAX, bid_Price+(Grid_Range*pip_Point));
   ChartSetDouble(0,CHART_FIXED_MIN, bid_Price-(Grid_Range*pip_Point));
         
//+------------------------------------------------------------------+
//| creating the objects for drawing the grid                        |
//+------------------------------------------------------------------+

   for(tf=0; tf<NTF; tf++)
   {
      for(i=0; i<NFL; i++)
      {
         objName = uniqueid + "fib_up_rect_" + (string)tf + "_" + (string)i;     // reset old objects
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, 0);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, 0); 
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, 0);
         
         objName = uniqueid + "fib_down_rect_" + (string)tf + "_" + (string)i;      // reset old objects
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, 0);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, 0);
         
         objName = uniqueid + "ext_fib_up_rect_" + (string)tf + "_" + (string)i;     // reset old objects
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, 0);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, 0); 
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, 0);
         
         objName = uniqueid + "ext_fib_down_rect_" + (string)tf + "_" + (string)i;      // reset old objects
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, 0);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, 0);
      }
   }            
      
   for(i=0; i<NFL; i++)  fib[i] = _fib[i]*pip_Point;
   for(tf=0; tf<NTF; tf++)
   {
      for(i=0; i<NFL; i++)
      {
         objName = uniqueid + "fib_up_rect_" + (string)tf + "_" + (string)i;     // upper zones
         ObjectCreate(0,objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
         ObjectSetInteger(0,objName, OBJPROP_COLOR, ShadeUpper[i]);
         ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
               
         objName = uniqueid + "ext_fib_up_rect_" + (string)tf;       // external upper zones
         ObjectCreate(0,objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
         ObjectSetInteger(0,objName, OBJPROP_COLOR, C'44,44,44');
         ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
                     
         objName = uniqueid + "fib_down_rect_" + (string)tf + "_" + (string)i;      // lower zones
         ObjectCreate(0,objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
         ObjectSetInteger(0,objName, OBJPROP_COLOR, ShadeLower[i]);
         ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
                     
         objName = uniqueid + "ext_fib_down_rect_" + (string)tf;        // external lower zones
         ObjectCreate(0,objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
         ObjectSetInteger(0,objName, OBJPROP_COLOR, C'44,44,44');
         ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
                     
         objName = uniqueid + "fib_up_level_" + (string)tf + "_" + (string)i;    // upper fib levels
         ObjectCreate(0,objName, OBJ_TEXT, 0, 0, 0, 0, 0);
         ObjectSetInteger(0,objName, OBJPROP_COLOR, clrBlack);
         ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
                     
         objName = uniqueid + "fib_down_level_" + (string)tf + "_" + (string)i;     // lower fib levels
         ObjectCreate(0,objName, OBJ_TEXT, 0, 0, 0, 0, 0);
         ObjectSetInteger(0,objName, OBJPROP_COLOR, clrBlack);
         ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
      }

         objName = uniqueid + "MidShade_" + (string)tf;                 // mid price zone
         ObjectCreate(0,objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
         ObjectSetInteger(0,objName, OBJPROP_COLOR, clrWhite);
         ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
         
      for(i=0; i<NMA; i++)
      {
         objName = uniqueid + "fma_" + (string)tf + "_" + (string)i;       // fibo MAs levels
         ObjectCreate(0,objName, OBJ_TEXT, 0, 0, 0, 0, 0);
         ObjectSetInteger(0,objName, OBJPROP_ANCHOR, ANCHOR_CENTER);
         ObjectSetInteger(0,objName, OBJPROP_COLOR, clrGray);
         ObjectSetInteger(0,objName, OBJPROP_FONTSIZE, 9);
         ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
      }

      for(i=1; i<=NSVL; i++)
      {
         objName = uniqueid + "svl_" + (string)tf + "_" + (string)i;    // solid vertical lines (10 pips or more)
         ObjectCreate(0,objName, OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSetInteger(0,objName, OBJPROP_RAY, false);
         ObjectSetInteger(0,objName, OBJPROP_WIDTH, 3);
         ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
            
         objName = uniqueid + "ext_up_svl_" + (string)tf;         // extern upper vertical lines
         ObjectCreate(0,objName, OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSetInteger(0,objName, OBJPROP_RAY, false);
         ObjectSetInteger(0,objName, OBJPROP_WIDTH, 3);
         ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
            
         objName = uniqueid + "ext_down_svl_" + (string)tf;       // extern lower vertical lines
         ObjectCreate(0,objName, OBJ_TREND, 0, 0, 0, 0, 0);
         ObjectSetInteger(0,objName, OBJPROP_RAY, false);
         ObjectSetInteger(0,objName, OBJPROP_WIDTH, 3);
         ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
      }
   }

//--------------------------------------------------------------------
//   Current Price  
   
   objName = uniqueid + "PriceScaleBG";  
   ObjectCreate(0,objName, OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_CORNER, CORNER_RIGHT_UPPER);    
   ObjectSetInteger(0,objName, OBJPROP_XDISTANCE, 43);
   ObjectSetInteger(0,objName, OBJPROP_YDISTANCE, -2);     
   ObjectSetInteger(0,objName, OBJPROP_XSIZE, 45);
   ObjectSetInteger(0,objName, OBJPROP_YSIZE, 3000);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, C'11,11,11');
   ObjectSetInteger(0,objName, OBJPROP_BGCOLOR, C'11,11,11');
   ObjectSetInteger(0,objName, OBJPROP_BORDER_COLOR, C'11,11,11');
   ObjectSetInteger(0,objName, OBJPROP_HIDDEN, false);
   ObjectSetInteger(0,objName, OBJPROP_STATE, false);
   
   objName = uniqueid + "Current_Price_";  
   ObjectCreate(0,objName, OBJ_TREND,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrGray);
   ObjectSetInteger(0,objName, OBJPROP_RAY, false);   
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);  
      
   objName = uniqueid + "Current_Price_BG";  
   ObjectCreate(0,objName, OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_CORNER, CORNER_RIGHT_UPPER);
   ObjectSetInteger(0,objName, OBJPROP_XDISTANCE, 0);
   ObjectSetInteger(0,objName, OBJPROP_YDISTANCE, 0);     
   ObjectSetInteger(0,objName, OBJPROP_XSIZE, 44);
   ObjectSetInteger(0,objName, OBJPROP_YSIZE, 18);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, C'33,33,33');
   ObjectSetInteger(0,objName, OBJPROP_BGCOLOR, C'33,33,33');
   ObjectSetInteger(0,objName, OBJPROP_BORDER_COLOR, C'11,11,11');
   ObjectSetInteger(0,objName, OBJPROP_HIDDEN, false);
   ObjectSetInteger(0,objName, OBJPROP_STATE, false);
   ObjectSetInteger(0,objName, OBJPROP_FONTSIZE, 9); 
   ObjectSetString(0,objName, OBJPROP_FONT, "Verdana");
   
      objName = uniqueid + "Current_Price"; 
   ObjectCreate(0,objName, OBJ_TEXT,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_ANCHOR, CORNER_RIGHT_UPPER);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrSilver);
   ObjectSetInteger(0,objName, OBJPROP_FONTSIZE, 12); 
   ObjectSetString(0,objName, OBJPROP_FONT, "Segue UI"); 
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);

      
//--------------------------------------------------------------------
//   Daily high/low
      
   objName = uniqueid + "Daily_High_";  
   ObjectCreate(0,objName, OBJ_TREND,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_STYLE, STYLE_DOT);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrFireBrick);
   ObjectSetInteger(0,objName, OBJPROP_RAY, false);   
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
   
   objName = uniqueid + "Daily_Low_";  
   ObjectCreate(0,objName, OBJ_TREND,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_STYLE, STYLE_DOT);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrGreen);
   ObjectSetInteger(0,objName, OBJPROP_RAY, false);     
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);

    
//--------------------------------------------------------------------
//   Weekly high/low
   
   objName = uniqueid + "Weekly_High_";  
   ObjectCreate(0,objName, OBJ_TREND,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_STYLE, STYLE_DASH);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrFireBrick);
   ObjectSetInteger(0,objName, OBJPROP_RAY, false);   
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
 
   objName = uniqueid + "Weekly_Low_";  
   ObjectCreate(0,objName, OBJ_TREND,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_STYLE, STYLE_DASH);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrGreen);
   ObjectSetInteger(0,objName, OBJPROP_RAY, false);     
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);

    
//--------------------------------------------------------------------
//   Monthly high/low
   
   objName = uniqueid + "Monthly_High_";  
   ObjectCreate(0,objName, OBJ_TREND,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrFireBrick);
   ObjectSetInteger(0,objName, OBJPROP_RAY, false);   
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
 
   objName = uniqueid + "Monthly_Low_";  
   ObjectCreate(0,objName, OBJ_TREND,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrGreen);
   ObjectSetInteger(0,objName, OBJPROP_RAY, false);     
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
 
 
//--------------------------------------------------------------------
//   X Daily high/low
   
   objName = uniqueid + "X_Daily_High_";  
   ObjectCreate(0,objName, OBJ_TREND,0,0,0,0); 
   ObjectSetInteger(0,objName, OBJPROP_STYLE, STYLE_DOT);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrGray);
   ObjectSetInteger(0,objName, OBJPROP_RAY, false);   
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
 
   objName = uniqueid + "X_Daily_Low_";  
   ObjectCreate(0,objName, OBJ_TREND,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_STYLE, STYLE_DOT);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrGray);
   ObjectSetInteger(0,objName, OBJPROP_RAY, false);     
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);

 
//--------------------------------------------------------------------
//    Daily Open
   
   objName = uniqueid + "Daily_Open_";  
   ObjectCreate(0,objName, OBJ_TREND,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_STYLE, STYLE_DOT);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrDarkSlateBlue);
   ObjectSetInteger(0,objName, OBJPROP_RAY, false);     
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);

  
//--------------------------------------------------------------------
//   Daily Info
 
   objName = uniqueid + "D1Range";    
   ObjectCreate(0,objName, OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_CORNER, CORNER_LEFT_UPPER);
   ObjectSetInteger(0,objName, OBJPROP_BORDER_COLOR, C'11,11,11');
   ObjectSetInteger(0,objName, OBJPROP_BGCOLOR, C'11,11,11');
   ObjectSetInteger(0,objName, OBJPROP_XDISTANCE, 1);
   ObjectSetInteger(0,objName, OBJPROP_YDISTANCE, -1);
   ObjectSetInteger(0,objName, OBJPROP_XSIZE, 40);
   ObjectSetInteger(0,objName, OBJPROP_YSIZE, 15);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrGray);
   ObjectSetInteger(0,objName, OBJPROP_FONTSIZE, 9);
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
   ObjectSetInteger(0,objName, OBJPROP_STATE, false); 

   objName = uniqueid + "D1Change";    
   ObjectCreate(0,objName, OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_CORNER, CORNER_LEFT_UPPER);
   ObjectSetInteger(0,objName, OBJPROP_BORDER_COLOR, C'11,11,11');
   ObjectSetInteger(0,objName, OBJPROP_BGCOLOR, C'11,11,11');
   ObjectSetInteger(0,objName, OBJPROP_XDISTANCE, 41);
   ObjectSetInteger(0,objName, OBJPROP_YDISTANCE, -1);
   ObjectSetInteger(0,objName, OBJPROP_XSIZE, 40);
   ObjectSetInteger(0,objName, OBJPROP_YSIZE, 15);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, clrGray);
   ObjectSetInteger(0,objName, OBJPROP_FONTSIZE, 9);
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
   ObjectSetInteger(0,objName, OBJPROP_STATE, false); 

//-------------------------------------------------------------------
//   H1 Candle
   
   objName = uniqueid + "Candle_Upper_Tail";
   ObjectCreate(0,objName, OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, C'33,33,33');
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);

   objName = uniqueid + "Candle_Body";
   ObjectCreate(0,objName, OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
   
   objName = uniqueid + "Candle_Lower_Tail";
   ObjectCreate(0,objName, OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSetInteger(0,objName, OBJPROP_COLOR, C'33,33,33');
   ObjectSetInteger(0,objName, OBJPROP_SELECTABLE, false);
         
   return(INIT_SUCCEEDED);
   }
   

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {       
   string lookFor = uniqueid;
   int lookForLength = StringLen(lookFor); 
   for(int x = ObjectsTotal(0,0,-1) - 1; x >= 0; x--)
      {
      string xname = ObjectName(0,x,0,-1);
      if(StringSubstr(xname, 0, lookForLength) == lookFor) ObjectDelete(0,xname);
      }
      
      

//ObjectsDeleteAll();
   ObjectDelete("WP_label");
   ObjectDelete("WP_line");
   ObjectDelete("WP_R38");
   ObjectDelete("WP_R38_label");
   ObjectDelete("WP_S38");
   ObjectDelete("WP_S38_label");
   ObjectDelete("WP_R61");
   ObjectDelete("WP_R61_label");
   ObjectDelete("WP_S61");
   ObjectDelete("WP_S61_label");
   ObjectDelete("WP_R78");
   ObjectDelete("WP_R78_label");
   ObjectDelete("WP_S78");
   ObjectDelete("WP_S78_label");
   ObjectDelete("WP_R100");
   ObjectDelete("WP_R100_label");
   ObjectDelete("WP_S100");
   ObjectDelete("WP_S100_label");
   ObjectDelete("WP_R138");
   ObjectDelete("WP_R138_label");
   ObjectDelete("WP_R161");
   ObjectDelete("WP_R161_label");
   ObjectDelete("WP_S138");
   ObjectDelete("WP_S138_label");
   ObjectDelete("WP_S161");
   ObjectDelete("WP_S161_label");
   ObjectDelete("WP_R200");
   ObjectDelete("WP_R200_label");
   ObjectDelete("WP_S200");
   ObjectDelete("WP_S200_label");
   ObjectDelete("Start");
   ObjectDelete("End");      
  } 
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   curTime = Time[0];
       
     
   bid_Price = Bid;
          
   pip_Point = 0.01;
   if(_Digits > 3) pip_Point = 0.0001;
   
   ChartSetDouble(0,CHART_FIXED_MAX, bid_Price+(Grid_Range*pip_Point));
   ChartSetDouble(0,CHART_FIXED_MIN, bid_Price-(Grid_Range*pip_Point));
   


//+------------------------------------------------------------------+
//| Time lines                                                       |
//+------------------------------------------------------------------+
    
   for(tf=0; tf<NTF; tf++)
   {
      for(i=0; i<NMA; i++)  fma[tf][i] = iMA(NULL, tfp[tf], fma_period[i], 0, MODE_SMA, PRICE_CLOSE, 0); // populating the fma array...
      for(i=0; i<NMA; i++) fmaArray[i] = fma[tf][i];                                                     // finding the highest and lowest MAs from the (7) fma's/MA's
      ArraySort(fmaArray);                                                                               // copying the MAs levels of this TF to one dim array to feed ArrayBsearch
         lowestMA  = fmaArray[0];
         highestMA = fmaArray[6];

      for(i=0; i<NFL; i++)                                                                               // populating the fibo arrays...
      {
         fib_up[tf][i]   = lowestMA  + fib[i];
         fib_down[tf][i] = highestMA - fib[i];
      }
   }

//+------------------------------------------------------------------+
//| drawing the color shades and fib levels                          |
//+------------------------------------------------------------------+

   for(tf=0; tf<NTF; tf++) 
   {
      offset = 0;                                                                // find the number of overlapping shades
      for(i=offset; i<NFL-1; i++) if(fib_up[tf][i] <= fib_down[tf][i]) offset++;

      if(offset > 0)                                                             // hide first level objects' overlapping, so they wont be left as 'ghosts'
      {
         objName = uniqueid + "fib_up_rect_" + (string)tf + "_" + (string)(NFL-2-offset+1);
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, 0);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, 0);
            
         objName = uniqueid + "fib_down_rect_" + (string)tf + "_" + (string)(NFL-2-offset+1);
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, 0);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, 0);
         
         objName = uniqueid + "fib_up_level_" + (string)tf + "_" + (string)(NFL-2-offset+1);
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, 0);
            
         objName = uniqueid + "fib_down_level_" + (string)tf + "_" + (string)(NFL-2-offset+1);
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, 0);
      }
        
      double highest=0;
      for(i=NFL-2; i>=offset; i--)
      {
         objName = uniqueid + "fib_up_rect_" + (string)tf + "_" + (string)(i-offset);
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+tf*spacing+width);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, fib_up[tf][i]);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, fib_up[tf][i+1]);
                
         if (fib_down[tf][i]>highest) highest=fib_up[tf][i+1];
            
         objName = uniqueid + "fib_up_level_" + (string)tf + "_" + (string)(i-offset);
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, fib_up[tf][i]);
         ObjectSetInteger(0,objName, OBJPROP_ANCHOR, ANCHOR_CENTER);
         ObjectSetInteger(0,objName, OBJPROP_FONTSIZE, 11);
         ObjectSetString(0,objName, OBJPROP_FONT, "Segoe UI");
            
         string_1 = DoubleToString(fib_up[tf][i],_Digits);
         string_L = StringLen(string_1);
         string_x = StringSubstr(string_1, string_L-3, 2);
            
         ObjectSetString(0,objName, OBJPROP_TEXT, "-" + string_x + "-");         
      }

      double lowest=9999.9999;
      for(i=0; i<NFL-1; i++)
      {
         objName = uniqueid + "fib_down_rect_" + (string)tf + "_" + (string)(i-offset);
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+tf*spacing+width);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, fib_down[tf][i]);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, fib_down[tf][i+1]);
         
         if(fib_down[tf][i]<lowest) lowest=fib_down[tf][i+1];
            
         objName = uniqueid + "fib_down_level_" + (string)tf + "_" + (string)(i-offset);
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, fib_down[tf][i]);
         ObjectSetInteger(0,objName, OBJPROP_ANCHOR, ANCHOR_CENTER);
         ObjectSetInteger(0,objName, OBJPROP_FONTSIZE, 11);
         ObjectSetString(0,objName, OBJPROP_FONT, "Segoe UI");
            
         string_1 = DoubleToString(fib_down[tf][i],_Digits);
         string_L = StringLen(string_1);
         string_x = StringSubstr(string_1, string_L-3, 2);

         ObjectSetString(0,objName,OBJPROP_TEXT, "-" + string_x + "-");
      }

         objName = uniqueid + "MidShade_" + (string)tf;
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+tf*spacing+width);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, fib_up[tf][offset]);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, fib_down[tf][offset]);
      
         objName = uniqueid + "ext_fib_up_rect_" + (string)tf;
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+tf*spacing+width);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, highest);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, WindowPriceMax());
            
         objName = uniqueid + "ext_up_svl_" + (string)tf;
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+tf*spacing+width/2);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, highest);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, WindowPriceMax());   
         ObjectSetInteger(0,objName, OBJPROP_COLOR, clrNONE);
      
         objName = uniqueid + "ext_fib_down_rect_" + (string)tf;
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+tf*spacing+width);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, lowest);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, WindowPriceMin());
        
         objName = uniqueid + "ext_down_svl_" + (string)tf;
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+tf*spacing+width/2);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, lowest);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, WindowPriceMin());
         ObjectSetInteger(0,objName, OBJPROP_COLOR, clrNONE);

//+------------------------------------------------------------------+
//| drawing the fma price levels and "boxes"                         |
//+------------------------------------------------------------------+

      for(i=0; i<NMA; i++)
      {
         objName = uniqueid + "fma_" + (string)tf + "_" + (string)i;
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, fma[tf][i]);
         
         if(i==0)
         {            
            if(fma[tf][i] >= bid_Price) col = C'255,162,145';
            else col = C'186,252,186';
            
            
            ObjectSetInteger(0,objName, OBJPROP_COLOR, col);
            ObjectSetInteger(0,objName, OBJPROP_FONTSIZE, 13);
            ObjectSetString(0,objName, OBJPROP_FONT, "Wingdings");
            ObjectSetString(0,objName, OBJPROP_TEXT, "u");
            ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2-1 *xUnit);

                       
            
            string_1 = DoubleToString(fma[tf][i],_Digits);
            string_L = StringLen(string_1);
            string_x = StringSubstr(string_1, string_L-3, 2);
                        
            ObjectSetInteger(0,objName+"_", OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2);
            ObjectSetDouble(0,objName+"_", OBJPROP_PRICE,0, fma[tf][i]);
            ObjectSetString(0,objName+"_", OBJPROP_TEXT, string_x);   
         }
         
                  if(i==1)
         {            
            if(fma[tf][i] >= bid_Price) col = C'255,134,113';
            else col = C'124,250,124';
            
            
            ObjectSetInteger(0,objName, OBJPROP_COLOR, col);
            ObjectSetInteger(0,objName, OBJPROP_FONTSIZE, 13);
            ObjectSetString(0,objName, OBJPROP_FONT, "wingdings");
            ObjectSetString(0,objName, OBJPROP_TEXT, "u");
            ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2-1 *xUnit);

                       
            
            string_1 = DoubleToString(fma[tf][i],_Digits);
            string_L = StringLen(string_1);
            string_x = StringSubstr(string_1, string_L-3, 2);
                        
            ObjectSetInteger(0,objName+"_", OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2);
            ObjectSetDouble(0,objName+"_", OBJPROP_PRICE,0, fma[tf][i]);
            ObjectSetString(0,objName+"_", OBJPROP_TEXT, string_x);   
         }
           
       if(i==6)
         {
            if(fma[tf][i] >= bid_Price) col = C'236,0,0';
            else col = C'0,106,0';
            
            ObjectSetInteger(0,objName, OBJPROP_COLOR, col);
            ObjectSetInteger(0,objName, OBJPROP_FONTSIZE, 13);
            ObjectSetString(0,objName, OBJPROP_FONT, "Wingdings");
            ObjectSetString(0,objName, OBJPROP_TEXT, "u");
            ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2-1*xUnit);


            string_1 = DoubleToString(fma[tf][i],_Digits);
            string_L = StringLen(string_1);
            string_x = StringSubstr(string_1, string_L-3, 2);

            ObjectSetInteger(0,objName+"_", OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2);
            ObjectSetDouble(0,objName+"_", OBJPROP_PRICE,0, fma[tf][i]);
            ObjectSetString(0,objName+"_", OBJPROP_TEXT, string_x);                                    
         }
         
                           if (i<6 && i>1)
         {            
            if(fma[tf][i] >= bid_Price) col = C'255,90,90';
            else col = C'0,203,0';
            
            
            ObjectSetInteger(0,objName, OBJPROP_COLOR, col);
            ObjectSetInteger(0,objName, OBJPROP_FONTSIZE, 13);
            ObjectSetString(0,objName, OBJPROP_FONT, "Wingdings");
            ObjectSetString(0,objName, OBJPROP_TEXT, "u");
            ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2-1 *xUnit);

                       
            
            string_1 = DoubleToString(fma[tf][i],_Digits);
            string_L = StringLen(string_1);
            string_x = StringSubstr(string_1, string_L-3, 2);
                        
            ObjectSetInteger(0,objName+"_", OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2);
            ObjectSetDouble(0,objName+"_", OBJPROP_PRICE,0, fma[tf][i]);
            ObjectSetString(0,objName+"_", OBJPROP_TEXT, string_x);   
         }
      }

//+------------------------------------------------------------------+
//| drawing the solid vertical lines                                 |
//+------------------------------------------------------------------+
                                                             
      for(i=0; i<NSVL; i++)
      {      
         objName = uniqueid + "svl_" + (string)tf + "_" + (string)i;    // reset all svl
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, 0);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, 0);
      }   
            
      ArrayInitialize(srl, -1);
      for (i=0; i<NMA; i++) srl[i] = fma[tf][i];
      for (i=offset; i<NFL; i++)
      {
         srl[NMA+i] = fib_down[tf][i];
         srl[NMA+NFL+i] = fib_up[tf][i];
      }
      
      srl[NMA+2*NFL] = bid_Price;
      ArraySort(srl);

      c           = 0;        
      supports    = 0;
      resistances = 0;
      for(i=0; i<NMA+2*NFL+2; i++)
      {
         if(srl[i] > bid_Price) resistances++;
         if(srl[i] < bid_Price) supports++;
         if(-1 == srl[i])
            continue;
         if(srl[i+1]-srl[i] >= gap*pip_Point)   // looking for a gap of 10 pips or more
         {
            c++;
            objName = uniqueid + "svl_" + (string)tf + "_" + (string)c;
               ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift+tf*spacing+width/2);
               ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+tf*spacing+width/2);
               ObjectSetDouble(0,objName, OBJPROP_PRICE,0, srl[i]+_Point*11);
               ObjectSetDouble(0,objName, OBJPROP_PRICE,1, srl[i+1]-_Point*10);

            if (srl[i+1] <= bid_Price)
            {
               if(bid_Price==srl[i+1]) short_gap_count++;
               ObjectSetInteger(0,objName, OBJPROP_COLOR, clrFireBrick);
            }
            else
            {
               if(bid_Price==srl[i]) long_gap_count++;
               ObjectSetInteger(0,objName, OBJPROP_COLOR, clrGreen);
            }
         }
         
         if (srl[i+1]-srl[i] >= gap*pip_Point)
         {
            if(srl[i+1] <= bid_Price)
               if(bid_Price==srl[i+1]) sr_short_gap_count++;
               else
               if(bid_Price==srl[i])   sr_long_gap_count++;
         }

      }
      
      if(supports == 0) 
      {
         sr_short_gap_count++;
         short_gap_count++;
      }
      
      if(resistances == 0) 
      {
         sr_long_gap_count++;
         long_gap_count++;
      }

      if(c >= NSVL) Print("Warning: NSVL exceeded");
      else  // hide the unused vertical lines objects so they wont be left as 'ghosts' (only the first)
      {
         objName = uniqueid + "svl_" + (string)tf + "_" + (string)(c+1);
         ObjectSetInteger(0,objName, OBJPROP_TIME,0, 0);
         ObjectSetInteger(0,objName, OBJPROP_TIME,1, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,0, 0);
         ObjectSetDouble(0,objName, OBJPROP_PRICE,1, 0);
      }
   }

//--------------------------------------------------------------------
//   Current Price  

   objName = uniqueid + "PriceScaleBG";  
   ObjectSetInteger(0,objName, OBJPROP_STATE, false);
   
   objName = uniqueid + "Current_Price_";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+spacing*5-1*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, bid_Price);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,1, bid_Price);   

   long ChartH = ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0)/2;
      
   objName = uniqueid + "Current_Price_BG";  
   ObjectSetInteger(0,objName, OBJPROP_XDISTANCE, 70);
   ObjectSetInteger(0,objName, OBJPROP_YDISTANCE, ChartH-10);   
   ObjectSetInteger(0,objName, OBJPROP_STATE, false);

   objName = uniqueid + "Current_Price";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime-5*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, bid_Price);
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(bid_Price,_Digits-1));
      
//--------------------------------------------------------------------
//   Daily high/low

   double D1_high=iHigh(NULL, PERIOD_D1,0); 
   double D1_low=iLow(NULL, PERIOD_D1,0);     
      
   objName = uniqueid + "Daily_High_";
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+spacing*5-1*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, D1_high);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,1, D1_high);   

   objName = uniqueid + "Daily_Low_";
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+spacing*5-1*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, D1_low);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,1, D1_low);      

   objName = uniqueid + "Daily_High";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime-19*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, D1_high);
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(D1_high,_Digits-1));

   objName = uniqueid + "Daily_Low";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime-19*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, D1_low);
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(D1_low,_Digits-1));
   
//--------------------------------------------------------------------
//   Weekly high/low

   double W1_high=iHigh(NULL, PERIOD_W1,0); 
   double W1_low=iLow(NULL, PERIOD_W1,0);   
   
   objName = uniqueid + "Weekly_High_";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+spacing*5-1*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, W1_high);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,1, W1_high);   

   objName = uniqueid + "Weekly_Low_";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+spacing*5-1*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, W1_low);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,1, W1_low);    

   objName = uniqueid + "Weekly_High";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime-19*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, W1_high);
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(W1_high,_Digits-1));

   objName = uniqueid + "Weekly_Low";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime-19*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, W1_low);
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(W1_low,_Digits-1));
   
//--------------------------------------------------------------------
//   Monthly high/low

   double MN1_high=iHigh(NULL, PERIOD_MN1,0); 
   double MN1_low=iLow(NULL, PERIOD_MN1,0);    
   
   objName = uniqueid + "Monthly_High_";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+spacing*5-1*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, MN1_high);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,1, MN1_high);   

   objName = uniqueid + "Monthly_Low_";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+spacing*5-1*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, MN1_low);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,1, MN1_low);     

   objName = uniqueid + "Monthly_High";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime-19*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, MN1_high);
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(MN1_high,_Digits-1));

   objName = uniqueid + "Monthly_Low";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime-19*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, MN1_low);
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(MN1_low,_Digits-1));

//--------------------------------------------------------------------
//   X Daily high/low

   double XD1_high=iHigh(NULL, PERIOD_D1,1); 
   double XD1_low=iLow(NULL, PERIOD_D1,1);   
   
   objName = uniqueid + "X_Daily_High_";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+spacing*5-1*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, XD1_high);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,1, XD1_high);   

   objName = uniqueid + "X_Daily_Low_";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+spacing*5-1*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, XD1_low);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,1, XD1_low);   

   objName = uniqueid + "X_Daily_High";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime-19*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, XD1_high);
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(XD1_high,_Digits-1));

   objName = uniqueid + "X_Daily_Low";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime-19*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, XD1_low);
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(XD1_low,_Digits-1));

//--------------------------------------------------------------------
//    Daily Open

   double D1_open=iOpen(NULL, PERIOD_D1,0);   
   
   objName = uniqueid + "Daily_Open_";
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift+spacing*5-1*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, D1_open);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,1, D1_open);   

   objName = uniqueid + "Daily_Open";  
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime-19*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, D1_open);
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(D1_open,_Digits-1));
 
//--------------------------------------------------------------------
//   Daily Info
      
   double  D1_Range = (D1_high-D1_low)/_Point;
   double  D1_Change = (Bid-D1_open)/_Point;
   
   if (Bid > D1_open) col = clrGreen;
   if (Bid < D1_open) col = clrFireBrick;   
 
   objName = uniqueid + "D1Range";    
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(NormalizeDouble(D1_Range / 10, 1), 1));
   ObjectSetInteger(0,objName, OBJPROP_STATE, false); 

   objName = uniqueid + "D1Change";    
   ObjectSetInteger(0,objName, OBJPROP_COLOR, col);
   ObjectSetString(0,objName, OBJPROP_TEXT, DoubleToString(NormalizeDouble(D1_Change / 10, 1), 1));
   ObjectSetInteger(0,objName, OBJPROP_STATE, false); 
   
//-------------------------------------------------------------------
//   H1 Candle

   double H1_high=iHigh(NULL, PERIOD_H1,0); 
   double H1_low=iLow(NULL, PERIOD_H1,0);     
   double H1_open=iOpen(NULL, PERIOD_H1,0); 
   double H1_close=iClose(NULL, PERIOD_H1,0);
   
   if (H1_close > H1_open) col=clrGreen;
   if (H1_close < H1_open) col=clrFireBrick;
   
   objName = uniqueid + "Candle_Upper_Tail";
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift-10*xUnit-Additional_Width*xUnit);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift-2*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, H1_high);
   if (H1_close > H1_open) ObjectSetDouble(0,objName, OBJPROP_PRICE,1, H1_close);
   if (H1_close < H1_open) ObjectSetDouble(0,objName, OBJPROP_PRICE,1, H1_open);  

   objName = uniqueid + "Candle_Body";
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift-10*xUnit-Additional_Width*xUnit);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift-2*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, H1_open);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,1, H1_close); 
   ObjectSetInteger(0,objName, OBJPROP_COLOR, col);  
   
   objName = uniqueid + "Candle_Lower_Tail";
   ObjectSetInteger(0,objName, OBJPROP_TIME,0, curTime+shift-10*xUnit-Additional_Width*xUnit);
   ObjectSetInteger(0,objName, OBJPROP_TIME,1, curTime+shift-2*xUnit);
   ObjectSetDouble(0,objName, OBJPROP_PRICE,0, H1_low);
   if (H1_close > H1_open) ObjectSetDouble(0,objName, OBJPROP_PRICE,1, H1_open);
   if (H1_close < H1_open) ObjectSetDouble(0,objName, OBJPROP_PRICE,1, H1_close);
   
   //-------------------------------------------------------------------+
   //    Pivots
      
   if(brokercandle==true)
     {
      ObjectDelete("Start");
      ObjectDelete("End");
      switch(swaptf)
        {
         case 1:chose_tf=PERIOD_MN1;break;
         case 2:chose_tf=PERIOD_W1;break;
         case 3:chose_tf=PERIOD_D1;break;
        }
      wclose= iClose(Symbol(),chose_tf,1);
      wopen = iClose(Symbol(),chose_tf,1);
      whigh = iHigh(Symbol(),chose_tf,1);
      wlow=iLow(Symbol(),chose_tf,1);
     }
   else if(brokercandle==false)
     {
      ObjectDelete("Start");
      ObjectDelete("End");
      int BarShft_Start=iBarShift(Symbol(),PERIOD_H1,startofpivot);
      int BarShft_End=iBarShift(Symbol(),PERIOD_H1,endofpivot);
      wopen=iOpen(Symbol(),PERIOD_H1,BarShft_Start);
      wclose=iClose(Symbol(),PERIOD_H1,BarShft_End);
      int HighBar= iHighest(Symbol(),PERIOD_H1,MODE_HIGH,BarShft_Start-BarShft_End+1,BarShft_End);
      int LowBar = iLowest(Symbol(),PERIOD_H1,MODE_LOW,BarShft_Start-BarShft_End+1,BarShft_End);
      whigh= iHigh(Symbol(),PERIOD_H1,HighBar);
      wlow = iLow(Symbol(),PERIOD_H1,LowBar);
      //Comment("Start ", BarShft_Start, " End ", BarShft_End, "  High ", whigh, " Low ", wlow, " Open ", wopen, " Close ", wclose, " High ", whigh, " Low ", wlow );
      if(BarShft_Start<BarShft_End)
        {
         Alert("Error - Start time must be less than End time!");
        }
      if(StartEndLines==true)
        {
         ObjectCreate(0,"Start",OBJ_VLINE,0,startofpivot,0);
         ObjectSetInteger(0,"Start",OBJPROP_COLOR,clrLimeGreen);
         ObjectSetInteger(0,"Start",OBJPROP_WIDTH,0);
         ObjectSetInteger(0,"Start",OBJPROP_STYLE,2);

         ObjectCreate(0,"End",OBJ_VLINE,0,endofpivot,0);
         ObjectSetInteger(0,"End",OBJPROP_COLOR,clrTomato);
         ObjectSetInteger(0,"End",OBJPROP_WIDTH,0);
         ObjectSetInteger(0,"End",OBJPROP_STYLE,2);
        }
     }
   switch(pivot_meth)
     {
      case 1:calPivot = (whigh+wlow+wclose)/3;break;
      case 2:calPivot = (whigh+wlow+wclose+wclose)/4;break;
      case 3:calPivot = (whigh+wlow+wclose+wopen)/4;break;
      case 4:calPivot = (whigh+wlow+wopen+wopen)/4;break;
      case 5:calPivot = (whigh+wlow+wopen)/3;break;
     }

   calRange=(whigh-wlow);

   if(pivot_fib==true)
     {
      R38  = calRange*0.382+calPivot;
      R61  = calRange*0.618+calPivot;
      R78  = calRange*0.786+calPivot;
      R100 = calRange*1.00+calPivot;
      R138 = calRange*1.382+calPivot;
      R161 = calRange*1.618+calPivot;
      R200 = calRange*2.00+calPivot;

      S38  = calPivot-calRange*0.382;
      S61  = calPivot-calRange*0.618;
      S78  = calPivot-calRange*0.786;
      S100 = calPivot-calRange*1.00;
      S138 = calPivot-calRange*1.382;
      S161 = calPivot-calRange*1.618;
      S200 = calPivot-calRange*2.00;

      lableR38="R38 ";
      lableR61="R61 ";
      lableR78="R78 ";
      lableR100="R100 ";
      lableS38="S38 ";
      lableS61="S61 ";
      lableS78="S78 ";
      lableS100="S100 ";
     }
   else if(pivot_fib==false)
     {
      R1=2*calPivot-wlow;
      R2=calPivot+(whigh-wlow);
      R3=R2+(whigh-wlow);
      S1=2*calPivot-whigh;
      S2=calPivot-(whigh-wlow);
      S3=S2-(whigh-wlow);

      lableR38="R1";
      lableR61="R2";
      lableR100="R3";
      lableS38="S1";
      lableS61="S2";
      lableS100="S3";

      R38=R1;
      R61=R2;
      R100=R3;
      S38=S1;
      S61=S2;
      S100=S3;

      show_200=false;
     }
   if(ShortHorizontalLines==true)
     {
      ObjectCreate("WP_line",OBJ_TREND,0,Time[LL],calPivot,Time[0]+Period()*(900+SS),calPivot);
      ObjectSet("WP_line",OBJPROP_COLOR,chose_color_pivot);
      ObjectSet("WP_line",OBJPROP_WIDTH,width_of_pivot_line);
      ObjectSet("WP_line",OBJPROP_STYLE,line_style_of_pivot);
      ObjectSet("WP_line",OBJPROP_RAY,false);
      double WP_line_Price=ObjectGet("WP_line",OBJPROP_PRICE1);
      ObjectCreate("WP_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),calPivot);
      ObjectSetText("WP_label","Pivot: "+DoubleToStr(WP_line_Price,4),10,"Arial",label_color_pivot);

      ObjectCreate("WP_R38",OBJ_TREND,0,Time[LL],R38,Time[0]+Period()*(900+SS),R38);
      ObjectSet("WP_R38",OBJPROP_COLOR,chose_color_R38);
      ObjectSet("WP_R38",OBJPROP_WIDTH,width_of_R_line);
      ObjectSet("WP_R38",OBJPROP_STYLE,line_style_of_R);
      ObjectSet("WP_R38",OBJPROP_RAY,false);
      double WP_R38_Price=ObjectGet("WP_R38",OBJPROP_PRICE1);
      ObjectCreate("WP_R38_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R38);
      ObjectSetText("WP_R38_label",lableR38+DoubleToStr(WP_R38_Price,4),10,"Arial",label_color_R38);

      ObjectCreate("WP_S38",OBJ_TREND,0,Time[LL],S38,Time[0]+Period()*(900+SS),S38);
      ObjectSet("WP_S38",OBJPROP_COLOR,chose_color_S38);
      ObjectSet("WP_S38",OBJPROP_WIDTH,width_of_S_line);
      ObjectSet("WP_S38",OBJPROP_STYLE,line_style_of_S);
      ObjectSet("WP_S38",OBJPROP_RAY,false);
      double WP_S38_Price=ObjectGet("WP_S38",OBJPROP_PRICE1);
      ObjectCreate("WP_S38_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S38);
      ObjectSetText("WP_S38_label",lableS38+DoubleToStr(WP_S38_Price,4),10,"Arial",label_color_S38);

      ObjectCreate("WP_R61",OBJ_TREND,0,Time[LL],R61,Time[0]+Period()*(900+SS),R61);
      ObjectSet("WP_R61",OBJPROP_COLOR,chose_color_R61);
      ObjectSet("WP_R61",OBJPROP_WIDTH,width_of_R_line);
      ObjectSet("WP_R61",OBJPROP_STYLE,line_style_of_R);
      ObjectSet("WP_R61",OBJPROP_RAY,false);
      double WP_R61_Price=ObjectGet("WP_R61",OBJPROP_PRICE1);
      ObjectCreate("WP_R61_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R61);
      ObjectSetText("WP_R61_label",lableR61+DoubleToStr(WP_R61_Price,4),10,"Arial",label_color_R61);

      ObjectCreate("WP_S61",OBJ_TREND,0,Time[LL],S61,Time[0]+Period()*(900+SS),S61);
      ObjectSet("WP_S61",OBJPROP_COLOR,chose_color_S61);
      ObjectSet("WP_S61",OBJPROP_WIDTH,width_of_S_line);
      ObjectSet("WP_S61",OBJPROP_STYLE,line_style_of_S);
      ObjectSet("WP_S61",OBJPROP_RAY,false);
      double WP_S61_Price=ObjectGet("WP_S61",OBJPROP_PRICE1);
      ObjectCreate("WP_S61_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S61);
      ObjectSetText("WP_S61_label",lableS61+DoubleToStr(WP_S61_Price,4),10,"Arial",label_color_S61);

      ObjectCreate("WP_R78",OBJ_TREND,0,Time[LL],R78,Time[0]+Period()*(900+SS),R78);
      ObjectSet("WP_R78",OBJPROP_COLOR,chose_color_R78);
      ObjectSet("WP_R78",OBJPROP_WIDTH,width_of_R_line);
      ObjectSet("WP_R78",OBJPROP_STYLE,line_style_of_R);
      ObjectSet("WP_R78",OBJPROP_RAY,false);
      double WP_R78_Price=ObjectGet("WP_R78",OBJPROP_PRICE1);
      ObjectCreate("WP_R78_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R78);
      ObjectSetText("WP_R78_label",lableR78+DoubleToStr(WP_R78_Price,4),10,"Arial",label_color_R78);

      ObjectCreate("WP_S78",OBJ_TREND,0,Time[LL],S78,Time[0]+Period()*(900+SS),S78);
      ObjectSet("WP_S78",OBJPROP_COLOR,clrRed);
      ObjectSet("WP_S78",OBJPROP_WIDTH,width_of_S_line);
      ObjectSet("WP_S78",OBJPROP_STYLE,line_style_of_S);
      ObjectSet("WP_S78",OBJPROP_RAY,false);
      double WP_S78_Price=ObjectGet("WP_S78",OBJPROP_PRICE1);
      ObjectCreate("WP_S78_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S78);
      ObjectSetText("WP_S78_label",lableS78+DoubleToStr(WP_S78_Price,4),10,"Arial",clrRed);

      ObjectCreate("WP_R100",OBJ_TREND,0,Time[LL],R100,Time[0]+Period()*(900+SS),R100);
      ObjectSet("WP_R100",OBJPROP_COLOR,chose_color_R100);
      ObjectSet("WP_R100",OBJPROP_WIDTH,width_of_R_line);
      ObjectSet("WP_R100",OBJPROP_STYLE,line_style_of_R);
      ObjectSet("WP_R100",OBJPROP_RAY,false);
      double WP_R100_Price=ObjectGet("WP_R100",OBJPROP_PRICE1);
      ObjectCreate("WP_R100_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R100);
      ObjectSetText("WP_R100_label",lableR100+DoubleToStr(WP_R100_Price,4),10,"Arial",label_color_R100);

      ObjectCreate("WP_S100",OBJ_TREND,0,Time[LL],S100,Time[0]+Period()*(900+SS),S100);
      ObjectSet("WP_S100",OBJPROP_COLOR,chose_color_S100);
      ObjectSet("WP_S100",OBJPROP_WIDTH,width_of_S_line);
      ObjectSet("WP_S100",OBJPROP_STYLE,line_style_of_S);
      ObjectSet("WP_S100",OBJPROP_RAY,false);
      double WP_S100_Price=ObjectGet("WP_S100",OBJPROP_PRICE1);
      ObjectCreate("WP_S100_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S100);
      ObjectSetText("WP_S100_label",lableS100+DoubleToStr(WP_S100_Price,4),10,"Arial",label_color_S100);

      if(show_200==true)
        {
         ObjectCreate("WP_R200",OBJ_TREND,0,Time[LL],R200,Time[0]+Period()*(900+SS),R200);
         ObjectSet("WP_R200",OBJPROP_COLOR,chose_color_R200);
         ObjectSet("WP_R200",OBJPROP_WIDTH,width_of_R_line);
         ObjectSet("WP_R200",OBJPROP_STYLE,line_style_of_R);
         ObjectSet("WP_R200",OBJPROP_RAY,false);
         double WP_R200_Price=ObjectGet("WP_R200",OBJPROP_PRICE1);
         ObjectCreate("WP_R200_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R200);
         ObjectSetText("WP_R200_label","R200 "+DoubleToStr(WP_R200_Price,4),10,"Arial",label_color_R200);

         ObjectCreate("WP_S200",OBJ_TREND,0,Time[LL],S200,Time[0]+Period()*(900+SS),S200);
         ObjectSet("WP_S200",OBJPROP_COLOR,chose_color_S200);
         ObjectSet("WP_S200",OBJPROP_WIDTH,width_of_S_line);
         ObjectSet("WP_S200",OBJPROP_STYLE,line_style_of_S);
         ObjectSet("WP_S200",OBJPROP_RAY,false);
         double WP_S200_Price=ObjectGet("WP_S200",OBJPROP_PRICE1);
         ObjectCreate("WP_S200_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S200);
         ObjectSetText("WP_S200_label","S200 "+DoubleToStr(WP_S200_Price,4),10,"Arial",label_color_S200);

         ObjectCreate("WP_R138",OBJ_TREND,0,Time[LL],R138,Time[0]+Period()*(900+SS),R138);
         ObjectSet("WP_R138",OBJPROP_COLOR,chose_color_R138);
         ObjectSet("WP_R138",OBJPROP_WIDTH,width_of_R_line);
         ObjectSet("WP_R138",OBJPROP_STYLE,line_style_of_R);
         ObjectSet("WP_R138",OBJPROP_RAY,false);
         double WP_R138_Price=ObjectGet("WP_R138",OBJPROP_PRICE1);
         ObjectCreate("WP_R138_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R138);
         ObjectSetText("WP_R138_label","R138 "+DoubleToStr(WP_R138_Price,4),10,"Arial",label_color_R138);

         ObjectCreate("WP_S138",OBJ_TREND,0,Time[LL],S138,Time[0]+Period()*(900+SS),S138);
         ObjectSet("WP_S138",OBJPROP_COLOR,chose_color_S138);
         ObjectSet("WP_S138",OBJPROP_WIDTH,width_of_S_line);
         ObjectSet("WP_S138",OBJPROP_STYLE,line_style_of_S);
         ObjectSet("WP_S138",OBJPROP_RAY,false);
         double WP_S138_Price=ObjectGet("WP_S138",OBJPROP_PRICE1);
         ObjectCreate("WP_S138_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S138);
         ObjectSetText("WP_S138_label","S138 "+DoubleToStr(WP_S138_Price,4),10,"Arial",label_color_S138);

         ObjectCreate("WP_R161",OBJ_TREND,0,Time[LL],R161,Time[0]+Period()*(900+SS),R161);
         ObjectSet("WP_R161",OBJPROP_COLOR,chose_color_R161);
         ObjectSet("WP_R161",OBJPROP_WIDTH,width_of_R_line);
         ObjectSet("WP_R161",OBJPROP_STYLE,line_style_of_R);
         ObjectSet("WP_R161",OBJPROP_RAY,false);
         double WP_R161_Price=ObjectGet("WP_R161",OBJPROP_PRICE1);
         ObjectCreate("WP_R161_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R161);
         ObjectSetText("WP_R161_label","R161 "+DoubleToStr(WP_R161_Price,4),10,"Arial",label_color_R161);

         ObjectCreate("WP_S161",OBJ_TREND,0,Time[LL],S161,Time[0]+Period()*(900+SS),S161);
         ObjectSet("WP_S161",OBJPROP_COLOR,chose_color_S161);
         ObjectSet("WP_S161",OBJPROP_WIDTH,width_of_S_line);
         ObjectSet("WP_S161",OBJPROP_STYLE,line_style_of_S);
         ObjectSet("WP_S161",OBJPROP_RAY,false);
         double WP_S161_Price=ObjectGet("WP_S161",OBJPROP_PRICE1);
         ObjectCreate("WP_S161_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S161);
         ObjectSetText("WP_S161_label","S161 "+DoubleToStr(WP_S161_Price,4),10,"Arial",label_color_S161);
        }
        }else{
      ObjectCreate("WP_line",OBJ_HLINE,0,0,calPivot);
      ObjectSet("WP_line",OBJPROP_COLOR,chose_color_pivot);
      ObjectSet("WP_line",OBJPROP_WIDTH,width_of_pivot_line);
      ObjectSet("WP_line",OBJPROP_STYLE,line_style_of_pivot);
      ObjectSet("WP_line",OBJPROP_RAY,false);
      ObjectCreate("WP_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),calPivot);
      ObjectSetText("WP_label","Pivot",10,"Arial",label_color_pivot);

      ObjectCreate("WP_R38",OBJ_HLINE,0,0,R38);
      ObjectSet("WP_R38",OBJPROP_COLOR,chose_color_R38);
      ObjectSet("WP_R38",OBJPROP_WIDTH,width_of_R_line);
      ObjectSet("WP_R38",OBJPROP_STYLE,line_style_of_R);
      ObjectSet("WP_R38",OBJPROP_RAY,false);
      ObjectCreate("WP_R38_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R38);
      ObjectSetText("WP_R38_label",lableR38,10,"Arial",label_color_R38);

      ObjectCreate("WP_S38",OBJ_HLINE,0,0,S38);
      ObjectSet("WP_S38",OBJPROP_COLOR,chose_color_S38);
      ObjectSet("WP_S38",OBJPROP_WIDTH,width_of_S_line);
      ObjectSet("WP_S38",OBJPROP_STYLE,line_style_of_S);
      ObjectSet("WP_S38",OBJPROP_RAY,false);
      ObjectCreate("WP_S38_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S38);
      ObjectSetText("WP_S38_label",lableS38,10,"Arial",label_color_S38);

      ObjectCreate("WP_R61",OBJ_HLINE,0,0,R61);
      ObjectSet("WP_R61",OBJPROP_COLOR,chose_color_R61);
      ObjectSet("WP_R61",OBJPROP_WIDTH,width_of_R_line);
      ObjectSet("WP_R61",OBJPROP_STYLE,line_style_of_R);
      ObjectSet("WP_R61",OBJPROP_RAY,false);
      ObjectCreate("WP_R61_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R61);
      ObjectSetText("WP_R61_label",lableR61,10,"Arial",label_color_R61);

      ObjectCreate("WP_S61",OBJ_HLINE,0,0,S61);
      ObjectSet("WP_S61",OBJPROP_COLOR,chose_color_S61);
      ObjectSet("WP_S61",OBJPROP_WIDTH,width_of_S_line);
      ObjectSet("WP_S61",OBJPROP_STYLE,line_style_of_S);
      ObjectSet("WP_S61",OBJPROP_RAY,false);
      ObjectCreate("WP_S61_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S61);
      ObjectSetText("WP_S61_label",lableS61,10,"Arial",label_color_S61);

      ObjectCreate("WP_R78",OBJ_HLINE,0,0,R78);
      ObjectSet("WP_R78",OBJPROP_COLOR,chose_color_R78);
      ObjectSet("WP_R78",OBJPROP_WIDTH,width_of_R_line);
      ObjectSet("WP_R78",OBJPROP_STYLE,line_style_of_R);
      ObjectSet("WP_R78",OBJPROP_RAY,false);
      ObjectCreate("WP_R78_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R78);
      ObjectSetText("WP_R78_label",lableR78,10,"Arial",label_color_R78);

      ObjectCreate("WP_S78",OBJ_HLINE,0,0,S78);
      ObjectSet("WP_S78",OBJPROP_COLOR,clrRed);
      ObjectSet("WP_S78",OBJPROP_WIDTH,width_of_S_line);
      ObjectSet("WP_S78",OBJPROP_STYLE,line_style_of_S);
      ObjectSet("WP_S78",OBJPROP_RAY,false);
      ObjectCreate("WP_S78_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S78);
      ObjectSetText("WP_S78_label",lableS78,10,"Arial",clrRed);

      ObjectCreate("WP_R100",OBJ_HLINE,0,0,R100);
      ObjectSet("WP_R100",OBJPROP_COLOR,chose_color_R100);
      ObjectSet("WP_R100",OBJPROP_WIDTH,width_of_R_line);
      ObjectSet("WP_R100",OBJPROP_STYLE,line_style_of_R);
      ObjectSet("WP_R100",OBJPROP_RAY,false);
      ObjectCreate("WP_R100_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R100);
      ObjectSetText("WP_R100_label",lableR100,10,"Arial",label_color_R100);

      ObjectCreate("WP_S100",OBJ_HLINE,0,0,S100);
      ObjectSet("WP_S100",OBJPROP_COLOR,chose_color_S100);
      ObjectSet("WP_S100",OBJPROP_WIDTH,width_of_S_line);
      ObjectSet("WP_S100",OBJPROP_STYLE,line_style_of_S);
      ObjectSet("WP_S100",OBJPROP_RAY,false);
      ObjectCreate("WP_S100_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S100);
      ObjectSetText("WP_S100_label",lableS100,10,"Arial",label_color_S100);

      if(show_200==true)
        {
         ObjectCreate("WP_R200",OBJ_HLINE,0,0,R200);
         ObjectSet("WP_R200",OBJPROP_COLOR,chose_color_R200);
         ObjectSet("WP_R200",OBJPROP_WIDTH,width_of_R_line);
         ObjectSet("WP_R200",OBJPROP_STYLE,line_style_of_R);
         ObjectSet("WP_R200",OBJPROP_RAY,false);
         ObjectCreate("WP_R200_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R200);
         ObjectSetText("WP_R200_label","R200 ",10,"Arial",label_color_R200);

         ObjectCreate("WP_S200",OBJ_HLINE,0,0,S200);
         ObjectSet("WP_S200",OBJPROP_COLOR,chose_color_S200);
         ObjectSet("WP_S200",OBJPROP_WIDTH,width_of_S_line);
         ObjectSet("WP_S200",OBJPROP_STYLE,line_style_of_S);
         ObjectSet("WP_S200",OBJPROP_RAY,false);
         ObjectCreate("WP_S200_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S200);
         ObjectSetText("WP_S200_label","S200 ",10,"Arial",label_color_S200);

         ObjectCreate("WP_R138",OBJ_HLINE,0,0,R138);
         ObjectSet("WP_R138",OBJPROP_COLOR,chose_color_R138);
         ObjectSet("WP_R138",OBJPROP_WIDTH,width_of_R_line);
         ObjectSet("WP_R138",OBJPROP_STYLE,line_style_of_R);
         ObjectSet("WP_R138",OBJPROP_RAY,false);
         ObjectCreate("WP_R138_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R138);
         ObjectSetText("WP_R138_label","R138 ",10,"Arial",label_color_R138);

         ObjectCreate("WP_S138",OBJ_HLINE,0,0,S138);
         ObjectSet("WP_S138",OBJPROP_COLOR,chose_color_S138);
         ObjectSet("WP_S138",OBJPROP_WIDTH,width_of_S_line);
         ObjectSet("WP_S138",OBJPROP_STYLE,line_style_of_S);
         ObjectSet("WP_S138",OBJPROP_RAY,false);
         ObjectCreate("WP_S138_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S138);
         ObjectSetText("WP_S138_label","S138 ",10,"Arial",label_color_S138);

         ObjectCreate("WP_R161",OBJ_HLINE,0,0,R161);
         ObjectSet("WP_R161",OBJPROP_COLOR,chose_color_R161);
         ObjectSet("WP_R161",OBJPROP_WIDTH,width_of_R_line);
         ObjectSet("WP_R161",OBJPROP_STYLE,line_style_of_R);
         ObjectSet("WP_R161",OBJPROP_RAY,false);
         ObjectCreate("WP_R161_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),R161);
         ObjectSetText("WP_R161_label","R161 ",10,"Arial",label_color_R161);

         ObjectCreate("WP_S161",OBJ_HLINE,0,0,S161);
         ObjectSet("WP_S161",OBJPROP_COLOR,chose_color_S161);
         ObjectSet("WP_S161",OBJPROP_WIDTH,width_of_S_line);
         ObjectSet("WP_S161",OBJPROP_STYLE,line_style_of_S);
         ObjectSet("WP_S161",OBJPROP_RAY,false);
         ObjectCreate("WP_S161_label",OBJ_TEXT,0,Time[0]+Period()*(600+SS),S161);
         ObjectSetText("WP_S161_label","S161 ",10,"Arial",label_color_S161);
        }

     }  
   
   return(rates_total);
  }
  
  



//+------------------------------------------------------------------+


